io.vertx.core.http

## Interface ServerWebSocket

- All Superinterfaces:
    ReadStream<Buffer>, StreamBase, WebSocketBase, WriteStream<Buffer>

      public interface ServerWebSocket
      extends WebSocketBase

  Represents a server side WebSocket.

  Instances of this class are passed into a `HttpServer.webSocketHandler(io.vertx.core.Handler<io.vertx.core.http.ServerWebSocket>)` or provided when a WebSocket handshake is manually `HttpServerRequest.toWebSocket(io.vertx.core.Handler<io.vertx.core.AsyncResult<io.vertx.core.http.ServerWebSocket>>)`ed.

  Author:
    Tim Fox

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `accept()` Accept the WebSocket and terminate the WebSocket handshake.
    `Future<Void>` | `close()` Close the WebSocket sending the default close frame.
    `ServerWebSocket` | `closeHandler(Handler<Void> handler)` Set a close handler.
    `ServerWebSocket` | `drainHandler(Handler<Void> handler)` Set a drain handler on the stream.
    `ServerWebSocket` | `endHandler(Handler<Void> endHandler)` Set an end handler.
    `ServerWebSocket` | `exceptionHandler(Handler<Throwable> handler)` Set an exception handler on the read stream.
    `ServerWebSocket` | `fetch(long amount)` Fetch the specified `amount` of elements.
    `ServerWebSocket` | `frameHandler(Handler<WebSocketFrame> handler)` Set a frame handler on the connection.
    `ServerWebSocket` | `handler(Handler<Buffer> handler)` Set a data handler.
    `String` | `host()`
    `String` | `path()`
    `ServerWebSocket` | `pause()` Pause the `ReadStream`, it sets the buffer in `fetch` mode and clears the actual demand.
    `X509Certificate[]` | `peerCertificateChain()` Note: Java SE 5+ recommends to use javax.net.ssl.SSLSession#getPeerCertificates() instead of of javax.net.ssl.SSLSession#getPeerCertificateChain() which this method is based on.
    `String` | `query()`
    `void` | `reject()` Reject the WebSocket.
    `void` | `reject(int status)` Like `reject()` but with a `status`.
    `ServerWebSocket` | `resume()` Resume reading, and sets the buffer in `flowing` mode.
    `String` | `scheme()`
    `Future<Integer>` | `setHandshake(Future<Integer> future)` Like `setHandshake(Future, Handler)` but returns a `Future` of the asynchronous result
    `void` | `setHandshake(Future<Integer> future, Handler<AsyncResult<Integer>> handler)` Set an asynchronous result for the handshake, upon completion of the specified `future`, the WebSocket will either be accepted when the `future` succeeds with the HTTP 101 status code rejected when the `future` is succeeds with an HTTP status code different than 101 rejected when the `future` fails with the HTTP status code `500` The provided future might be completed by the WebSocket itself, e.g calling the `close()` method will try to accept the handshake and close the WebSocket afterward.
    `ServerWebSocket` | `setWriteQueueMaxSize(int maxSize)` Set the maximum size of the write queue to `maxSize`.
    `SSLSession` | `sslSession()`
    `String` | `uri()`
    `ServerWebSocket` | `writeBinaryMessage(Buffer data, Handler<AsyncResult<Void>> handler)` Same as `WebSocketBase.writeBinaryMessage(Buffer)` but with an `handler` called when the operation completes
    `ServerWebSocket` | `writeFinalBinaryFrame(Buffer data, Handler<AsyncResult<Void>> handler)` Same as `WebSocketBase.writeFinalBinaryFrame(Buffer, Handler)` but with an `handler` called when the operation completes
    `ServerWebSocket` | `writeFinalTextFrame(String text, Handler<AsyncResult<Void>> handler)` Same as `WebSocketBase.writeFinalTextFrame(String, Handler)` but with an `handler` called when the operation completes
    `ServerWebSocket` | `writeFrame(WebSocketFrame frame, Handler<AsyncResult<Void>> handler)` Same as `WebSocketBase.writeFrame(WebSocketFrame)` but with an `handler` called when the operation completes
    `ServerWebSocket` | `writeTextMessage(String text, Handler<AsyncResult<Void>> handler)` Same as `WebSocketBase.writeTextMessage(String)` but with an `handler` called when the operation completes

    - ### Methods inherited from interface io.vertx.core.http.WebSocketBase

      `binaryHandlerID, binaryMessageHandler, close, close, close, close, close, closeReason, closeStatusCode, end, end, headers, isClosed, isSsl, localAddress, pongHandler, remoteAddress, subProtocol, textHandlerID, textMessageHandler, writeBinaryMessage, writeFinalBinaryFrame, writeFinalTextFrame, writeFrame, writePing, writePing, writePong, writePong, writeTextMessage`

    - ### Methods inherited from interface io.vertx.core.streams.ReadStream

      `pipe, pipeTo, pipeTo`

    - ### Methods inherited from interface io.vertx.core.streams.WriteStream

      `end, end, write, write, writeQueueFull`

- - ### Method Detail

    - #### exceptionHandler

          ServerWebSocket exceptionHandler(Handler<Throwable> handler)

      Description copied from interface: `ReadStream`
      Set an exception handler on the read stream.
      Specified by:
        `exceptionHandler` in interface `ReadStream<Buffer>`
      Specified by:
        `exceptionHandler` in interface `StreamBase`
      Specified by:
        `exceptionHandler` in interface `WebSocketBase`
      Specified by:
        `exceptionHandler` in interface `WriteStream<Buffer>`
      Parameters:
        `handler` - the exception handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### handler

          ServerWebSocket handler(Handler<Buffer> handler)

      Description copied from interface: `ReadStream`
      Set a data handler. As data is read, the handler will be called with the data.
      Specified by:
        `handler` in interface `ReadStream<Buffer>`
      Specified by:
        `handler` in interface `WebSocketBase`
      Returns:
        a reference to this, so the API can be used fluently

    - #### pause

          ServerWebSocket pause()

      Description copied from interface: `ReadStream`
      Pause the `ReadStream`, it sets the buffer in `fetch` mode and clears the actual demand.

      While it's paused, no data will be sent to the data `handler`.

      Specified by:
        `pause` in interface `ReadStream<Buffer>`
      Specified by:
        `pause` in interface `WebSocketBase`
      Returns:
        a reference to this, so the API can be used fluently

    - #### resume

          ServerWebSocket resume()

      Description copied from interface: `ReadStream`
      Resume reading, and sets the buffer in `flowing` mode.

      If the `ReadStream` has been paused, reading will recommence on it.
      Specified by:
        `resume` in interface `ReadStream<Buffer>`
      Specified by:
        `resume` in interface `WebSocketBase`
      Returns:
        a reference to this, so the API can be used fluently

    - #### fetch

          ServerWebSocket fetch(long amount)

      Description copied from interface: `ReadStream`
      Fetch the specified `amount` of elements. If the `ReadStream` has been paused, reading will recommence with the specified `amount` of items, otherwise the specified `amount` will be added to the current stream demand.
      Specified by:
        `fetch` in interface `ReadStream<Buffer>`
      Specified by:
        `fetch` in interface `WebSocketBase`
      Returns:
        a reference to this, so the API can be used fluently

    - #### endHandler

          ServerWebSocket endHandler(Handler<Void> endHandler)

      Description copied from interface: `ReadStream`
      Set an end handler. Once the stream has ended, and there is no more data to be read, this handler will be called.
      Specified by:
        `endHandler` in interface `ReadStream<Buffer>`
      Specified by:
        `endHandler` in interface `WebSocketBase`
      Returns:
        a reference to this, so the API can be used fluently

    - #### setWriteQueueMaxSize

          ServerWebSocket setWriteQueueMaxSize(int maxSize)

      Description copied from interface: `WriteStream`
      Set the maximum size of the write queue to `maxSize`. You will still be able to write to the stream even if there is more than `maxSize` items in the write queue. This is used as an indicator by classes such as `Pipe` to provide flow control.

      The value is defined by the implementation of the stream, e.g in bytes for a `NetSocket`, etc...
      Specified by:
        `setWriteQueueMaxSize` in interface `WebSocketBase`
      Specified by:
        `setWriteQueueMaxSize` in interface `WriteStream<Buffer>`
      Parameters:
        `maxSize` - the max size of the write stream
      Returns:
        a reference to this, so the API can be used fluently

    - #### drainHandler

          ServerWebSocket drainHandler(Handler<Void> handler)

      Description copied from interface: `WriteStream`
      Set a drain handler on the stream. If the write queue is full, then the handler will be called when the write queue is ready to accept buffers again. See `Pipe` for an example of this being used.

      The stream implementation defines when the drain handler, for example it could be when the queue size has been reduced to `maxSize / 2`.

      Specified by:
        `drainHandler` in interface `WebSocketBase`
      Specified by:
        `drainHandler` in interface `WriteStream<Buffer>`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### writeFrame

          ServerWebSocket writeFrame(WebSocketFrame frame,
                                     Handler<AsyncResult<Void>> handler)

      Description copied from interface: `WebSocketBase`
      Same as `WebSocketBase.writeFrame(WebSocketFrame)` but with an `handler` called when the operation completes
      Specified by:
        `writeFrame` in interface `WebSocketBase`

    - #### writeFinalTextFrame

          ServerWebSocket writeFinalTextFrame(String text,
                                              Handler<AsyncResult<Void>> handler)

      Description copied from interface: `WebSocketBase`
      Same as `WebSocketBase.writeFinalTextFrame(String, Handler)` but with an `handler` called when the operation completes
      Specified by:
        `writeFinalTextFrame` in interface `WebSocketBase`

    - #### writeFinalBinaryFrame

          ServerWebSocket writeFinalBinaryFrame(Buffer data,
                                                Handler<AsyncResult<Void>> handler)

      Description copied from interface: `WebSocketBase`
      Same as `WebSocketBase.writeFinalBinaryFrame(Buffer, Handler)` but with an `handler` called when the operation completes
      Specified by:
        `writeFinalBinaryFrame` in interface `WebSocketBase`

    - #### writeBinaryMessage

          ServerWebSocket writeBinaryMessage(Buffer data,
                                             Handler<AsyncResult<Void>> handler)

      Description copied from interface: `WebSocketBase`
      Same as `WebSocketBase.writeBinaryMessage(Buffer)` but with an `handler` called when the operation completes
      Specified by:
        `writeBinaryMessage` in interface `WebSocketBase`

    - #### writeTextMessage

          ServerWebSocket writeTextMessage(String text,
                                           Handler<AsyncResult<Void>> handler)

      Description copied from interface: `WebSocketBase`
      Same as `WebSocketBase.writeTextMessage(String)` but with an `handler` called when the operation completes
      Specified by:
        `writeTextMessage` in interface `WebSocketBase`

    - #### closeHandler

          ServerWebSocket closeHandler(Handler<Void> handler)

      Description copied from interface: `WebSocketBase`
      Set a close handler. This will be called when the WebSocket is closed.

      After this callback, no more messages are expected. When the WebSocket received a close frame, the `WebSocketBase.closeStatusCode()` will return the status code and `WebSocketBase.closeReason()` will return the reason.
      Specified by:
        `closeHandler` in interface `WebSocketBase`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### frameHandler

          ServerWebSocket frameHandler(Handler<WebSocketFrame> handler)

      Description copied from interface: `WebSocketBase`
      Set a frame handler on the connection. This handler will be called when frames are read on the connection.
      Specified by:
        `frameHandler` in interface `WebSocketBase`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### scheme

          String scheme()

      Returns:
        the WebSocket handshake scheme

    - #### host

          String host()

      Returns:
        the WebSocket handshake host

    - #### uri

          String uri()

    - #### path

          String path()

      Returns:
        the WebSocket handshake path.

    - #### query

          String query()

      Returns:
        the WebSocket handshake query string.

    - #### accept

          void accept()

      Accept the WebSocket and terminate the WebSocket handshake.

      This method should be called from the WebSocket handler to explicitly accept the WebSocket and terminate the WebSocket handshake.
      Throws:
        `IllegalStateException` - when the WebSocket handshake is already set

    - #### reject

          void reject()

      Reject the WebSocket.

      Calling this method from the WebSocket handler when it is first passed to you gives you the opportunity to reject the WebSocket, which will cause the WebSocket handshake to fail by returning a 502 response code.

      You might use this method, if for example you only want to accept WebSockets with a particular path.

      Throws:
        `IllegalStateException` - when the WebSocket handshake is already set

    - #### reject

          void reject(int status)

      Like `reject()` but with a `status`.

    - #### setHandshake

          void setHandshake(Future<Integer> future,
                            Handler<AsyncResult<Integer>> handler)

      Set an asynchronous result for the handshake, upon completion of the specified `future`, the WebSocket will either be
      - accepted when the `future` succeeds with the HTTP 101 status code
      - rejected when the `future` is succeeds with an HTTP status code different than 101
      - rejected when the `future` fails with the HTTP status code `500`
      The provided future might be completed by the WebSocket itself, e.g calling the `close()` method will try to accept the handshake and close the WebSocket afterward. Thus it is advised to try to complete the `future` with `Promise.tryComplete(T)` or `Promise.tryFail(java.lang.Throwable)`.

      This method should be called from the WebSocket handler to explicitly set an asynchronous handshake.

      Calling this method will override the `future` completion handler.

      Parameters:
        `future` - the future to complete with
        `handler` - the completion handler
      Throws:
        `IllegalStateException` - when the WebSocket has already an asynchronous result

    - #### setHandshake

          Future<Integer> setHandshake(Future<Integer> future)

      Like `setHandshake(Future, Handler)` but returns a `Future` of the asynchronous result

    - #### close

          Future<Void> close()

      Close the WebSocket sending the default close frame.

      No more messages can be sent.

      The WebSocket handshake will be accepted when it hasn't yet been settled or when an asynchronous handshake is in progress.

      Specified by:
        `close` in interface `WebSocketBase`
      Returns:
        a future completed with the result

    - #### sslSession

          SSLSession sslSession()

      Specified by:
        `sslSession` in interface `WebSocketBase`
      Returns:
        SSLSession associated with the underlying socket. Returns null if connection is not SSL.
      See Also:
        `SSLSession`

    - #### peerCertificateChain

          X509Certificate[] peerCertificateChain()
                                          throws SSLPeerUnverifiedException

      Note: Java SE 5+ recommends to use javax.net.ssl.SSLSession#getPeerCertificates() instead of of javax.net.ssl.SSLSession#getPeerCertificateChain() which this method is based on. Use `sslSession()` to access that method.
      Specified by:
        `peerCertificateChain` in interface `WebSocketBase`
      Returns:
        an ordered array of the peer certificates. Returns null if connection is not SSL.
      Throws:
        `SSLPeerUnverifiedException` - SSL peer's identity has not been verified.
      See Also:
        `SSLSession.getPeerCertificateChain()`, `sslSession()`

Copyright © 2021 Eclipse. All rights reserved.